#!/bin/sh
#| -*- mode: scheme; coding: utf-8; -*- |#
:; exec gosh -I. -- $0 "$@"

;; fetch some test data from OpenStreetMap
;; output linestrings as text suitable for test3.cpp

(use rfc.json)
(use rfc.http)
(use gauche.sequence)
(use math.const)

(define (mercator p :optional (r 6378137))
  (let ((xs (/ (* pi r) 180)))
    (list (* (car p) xs)
	  (* (log (tan (* (+ (cadr p) 90) (/ pi 360))))
             r))))

(define *query*
  "[out:json];
(
way[\"highway\"](48.4,8.9,48.6,9.1);
);
out geom;
")

(define (main args)
  (print "# some linestrings based on OpenStreetMap data")
  (print "# © OpenStreetMap contributors")
  (print "# http://www.openstreetmap.org/copyright")
  (receive (status headers body)
      (http-get "overpass-api.de" (http-compose-query "/api/interpreter" `((data ,*query*))))
    (for-each (lambda(way)
		(let1 geometry (assoc-ref way "geometry")
		  (print (size-of geometry))
		  (map (lambda(p)
			 (let1 p (mercator (list (assoc-ref p "lon") (assoc-ref p "lat")))
			   (print (car p) " " (cadr p))))
		       geometry)))
	      (assoc-ref (parse-json-string body) "elements")))
  0)
